program _21_dprog_razmen;
{$APPTYPE CONSOLE}
{
      11 
 ..   .. .
  6.
   21.  .
                   -  
   Delphi.  
}

uses
  SysUtils, Windows;

const MMAX = 4;
      WMAX = 100;

var T: array[1..MMAX,0..WMAX] of longint;
    P: array[1..MMAX] of integer;
    i, w, k, N: integer;

function RazmenPerebor ( N: integer ): integer;
var i1, i2, i5, i10, K10, K5, K2: integer;
    count: longint;
begin
  count:=  0;
  for i10:=0 to N div P[4] do begin
    K10:= N - i10*P[4];
    for i5:=0 to K10 div P[3] do begin
      K5:= N - i10*P[4] - i5*P[3];
      for i2:=0 to K5 div P[2] do begin
        K2:= N - i10*P[4] - i5*P[3] -i2*P[2];
        if K2 mod P[1] = 0 then
          count:= count + 1;
      end;
    end;
  end;
  RazmenPerebor:= count;
end;

procedure showTable;
var i, w: integer;
begin
  write(' ':3);
  for w:=0 to N do write(w:3);
  writeln;
  for i:=1 to N+2 do write('---');
  writeln;
  for i:=1 to MMAX do begin
    write(P[i]:2,':');
    for w:=0 to N do write(T[i,w]:3);
    writeln;
  end;
  writeln;
end;


begin

  //     CP1251 (Windows-1251).
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);
  //        , 
  //     (    ),  "".
  //       ""    : "Lucida Console".

  P[1]:=1; P[2]:=2; P[3]:=5; P[4]:=10;

  writeln ( '   ' );
  for i:=1 to MMAX do begin
    if i > 1 then
      if i = MMAX then write ( '  ' )
      else write ( ', ' );
    write ( P[i] );
    if i = MMAX then writeln ( ' .' );
  end;

  repeat
    write ( '    (1..', WMAX, '): ' );
    readln ( N );
  until (1 <= N) and (N <= WMAX);

  for i:=P[1] to N do
    T[1,i]:=1;

  for i:=1 to MMAX do
    T[i,0]:=1;

  for i:=2 to MMAX do begin
    for w:=1 to N do begin
      T[i,w] := T[i-1,w];
      if w >= P[i] then
        T[i,w] := T[i,w] + T[i,w-P[i]];
    end;
  end;

  showTable;

  writeln ( '  : ', T[MMAX,N] );
  writeln ( '  ... ' );
  writeln ( '    : ', RazmenPerebor(N) );

  readln;

end.
