program _18_dprog_fib;
{$APPTYPE CONSOLE}
{
      11 
 ..   .. .
  6.
   18.  .
                  
   Delphi.
}

uses
  SysUtils, Windows;

const N = 45;

var F: array[1..N] of longint;
    t0, t1: double;
    i, FN, f1, f2: longint;

function Fib(N: longint): longint;
begin
  if N < 3 then Fib:=1
  else Fib:= Fib(N-1) + Fib(N-2);
end;

function timeSec: double;
const secDay = 24 * 60 * 60;
begin
  Result := Frac(Time) * secDay ;
end;

begin

  //     CP1251 (Windows-1251).
  SetConsoleCP(1251);
  SetConsoleOutputCP(1251);
  //        , 
  //     (    ),  "".
  //       ""    : "Lucida Console".
  writeln(' F(', N, ') ...');

  t0:=timeSec;
  FN := Fib(N);
  t1:=timeSec;
  writeln(' :');
  writeln('  F(', N, ') = ', FN, ',  ', (t1-t0):0:2, ' ');

  t0:=timeSec;
  F[1]:=1; F[2]:=1;
  for i:=3 to N do
   F[i] := F[i-1] + F[i-2];
  t1:=timeSec;
  writeln('     ');
  writeln('  F(', N, ') = ', F[N], ',  ', (t1-t0):0:2, ' ');

  t0:=timeSec;
  f2:=1; f1:=1;
  for i:=3 to N do begin
    FN := f1 + f2;
    f2 := f1;
    f1 := FN;
  end;
  t1:=timeSec;
  writeln('  ');
  writeln('  F(', N, ') = ', F[N], ',  ', (t1-t0):0:2, ' ');
  readln;
end.
