program structSort;
{
 Программа к учебнику информатики для 11 класса
 К.Ю. Полякова и Е.А. Еремина.
 Глава 6.
 Программа № 5. Сортировка структур
}
type
  TBook = record
    author: string[40];  { автор, строка }
    title: string[80];   { название, строка}
    count: integer;      { количество, целое }
  end;
  PBook = ^TBook;

const N = 100;
var B: TBook;
    Books: array[1..N] of TBook;
    p: array[1..N] of PBook;
    p1: PBook;
    F: file of TBook;
    i, j, M: integer;
begin

  for i:=1 to N do p[i]:= @Books[i];

  Assign(F, 'books.dat');
  Reset(F);
  M := 0;
  while not eof(F) do begin
    Inc(M);
    read(F, Books[M]);
  end;
  Close(F);

  writeln;
  writeln('Имеющиеся данные о книгах:');
  for i:=1 to M do
    writeln(' ', Books[i].author, ', ', Books[i].title, ', ',
            Books[i].count);

  for i:= 1 to M-1 do
    for j:= M-1 downto i do
      if p[j]^.author > p[j+1]^.author then begin
        p1:= p[j]; p[j]:= p[j+1];
        p[j+1]:= p1;
      end;

  writeln;
  writeln('После сортировки через указатели:');
  for i:=1 to M do
    writeln(' ', p[i]^.author, ', ', p[i]^.title, ', ',
            p[i]^.count);

  for i:=1 to M-1 do
    for j:=M-1 downto i do
      if Books[j].author > Books[j+1].author then
      begin
        B:= Books[j]; Books[j]:= Books[j+1];
        Books[j+1]:= B;
      end;

  writeln;
  writeln('После сортировки перестанвкой:');
  for i:=1 to M do
    writeln(' ', Books[i].author, ', ', Books[i].title, ', ',
            Books[i].count);

  Assign(F, 'books_sort.dat');
  Rewrite(F);
  for i:=1 to M do
      write(F, Books[i]);
  Close(F);

  writeln;
  writeln('Данные сохранены в файле books_sort.dat');
  readln;
end.
